<!DOCTYPE html>
<html lang="en">

<head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>homework15_optional_factorial</title>
</head>

<body>
  <script>
    'use strict';

    let factorialNumber;
    let result;

    function getValue(text, value) {
      return prompt(`Enter ${text} number (integer, >= 0)`, value);
    }

    function setNumber(text, num) {
      do {
        num = getValue(text, num);

        if (num === null) {
          console.log('You canceled programm');
          break;
        }
        else if (num === '' || num[0] === ' ') {
          num = undefined;
        }
        else if (isFinite(num)) {
          num = Number(num);
        }
      } while (!isFinite(num) || num < 0 || !Number.isInteger(num));
      return num;
    }

    function calcFactorial(num) {
      return (num < 1) ? 1 : num * calcFactorial(num - 1);
    }

    factorialNumber = setNumber('for factorial', factorialNumber);

    if (Number.isFinite(factorialNumber)) {
      result = calcFactorial(factorialNumber);
    }

    if (Number.isFinite(result)) {
      console.log(`Result: Factorial ${factorialNumber}! = ${result}`);
    } else {
      console.log('Error calculate');
    }

  </script>
</body>

</html>